// Header File
// Created 29/06/2005; 16:20:56
#ifndef __HAWK_graphique_H__
#define __HAWK_graphique_H__

//==========================================================================//
//	Autres fonctions graphiques que celles d'Extgraph
//==========================================================================//

void SauveImg(unsigned char * buffer, void * screen_0, void * screen_1)
{
	FastCopyScreen_R(screen_0, buffer);
	FastCopyScreen_R(screen_1, buffer+LCD_SIZE);
}

//==========================================================================//

void RestaureImg(unsigned char * buffer, void * screen_0, void * screen_1)
{
	FastCopyScreen_R(buffer, screen_0);
	FastCopyScreen_R(buffer+LCD_SIZE, screen_1);
}

//==========================================================================//

void GrayClrPix(short x, short y, void * screen_0, void * screen_1)
{
	EXT_CLRPIX(screen_0, x, y+ADAPT_Y);
	EXT_CLRPIX(screen_1, x, y+ADAPT_Y);
}

//==========================================================================//

void GraySetPix(short x, short y, void * screen_0, void * screen_1)
{
	EXT_SETPIX(screen_0, x, y+ADAPT_Y);
	EXT_SETPIX(screen_1, x, y+ADAPT_Y);
}

//==========================================================================//
//	Utilise les symtries du cercle pour en dessiner un plein
//==========================================================================//

void DessineLignes(void * screen_0, void * screen_1, short color, short x, short y, short x_centre, short y_centre)
{
 GrayFastDrawHLine2B(y_centre+y, y_centre-y, x_centre+x, color, screen_0, screen_1);
 GrayFastDrawHLine2B(y_centre+y, y_centre-y, x_centre-x, color, screen_0, screen_1);
 GrayFastDrawHLine2B(y_centre+x, y_centre-x, x_centre+y, color, screen_0, screen_1);
 GrayFastDrawHLine2B(y_centre+x, y_centre-x, x_centre-y, color, screen_0, screen_1);
}

//==========================================================================//

void DessineCerclePlein(void * screen_0, void * screen_1, short color, short rayon, short x_centre, short y_centre)
{
 register short x, y, d;

 x = 0;
 y = rayon;
 d = (5-rayon)/4;
 
 DessineLignes(screen_0, screen_1, color, x, y, y_centre, x_centre);
 
 while(y > x)
 {
 	if(d < 0)
 	{
 		d += x+x+3;
 	}
 	else
 	{
 		d += x+x-y-y+5;
 		y --;
 	}
 	
 	x ++;
 	DessineLignes(screen_0, screen_1, color, x, y, y_centre, x_centre);
 }
 
}

//==========================================================================//

#endif