// Header File
// Created 10/08/2005; 12:51:57
#ifndef __HAWK_prototypes_H__
#define __HAWK_prototypes_H__

//==========================================================================//
//	Structure des animations
//==========================================================================//

typedef struct
{
	short x;													//	Coordonnes de
	short y;													//	l'animation
	char cycles_anim;									//	Nombre de cycles (tapes) dans l'animation
	char etape_anim;									//	Etape courante dans l'animation
	short indice_anim;								// 	Numro de l'animation dans les listes 'animations_0' et 'animations_1'
	short hauteur;										// 	Hauteur de l'animation (pour les collisions ...)
	short largeur;										// 	Idem pour la largeur
	short compteur_incr;							// 	Compteur pour l'indice dans la liste d'incrmentation
	short tempo;											// 	Tempo de dplacement
	short compteur;										// 	Compteur interne  l'animation
	short dead;												// 	Nombre de tirs avant que ne meure l'animation
	short indice_incr;								//	Indice dans la matrice d'incrmentations
	short flag_proj;									//	Indique si l'animation lance ou non des projectiles
	short x_proj_offset;							//	Coordonnes du projectile
	short y_proj_offset;							//	lorsqu'il sort de l'animation
	short x_proj_incr;								//	Valeurs
	short y_proj_incr;								//	d'incrmentation
	short tempo_proj;									//	Tempo de gnration d'un projectile
} ANIM;

ANIM animation[20] = {};	// 20 simultanes au maximum

//==========================================================================//
//	Dclaration de tous les prototypes
//==========================================================================//

static inline void AlloueMemoire(void);
static inline void LibereMemoire(void);
static inline char * GenerateTIOSName(char *, char *);
static inline SYM_ENTRY * GetSymByName(char *);
static inline char * FindFile(const char *);
static inline void Installation(void);

//==========================================================================//

void RedirigeInterruptions(void);
void RestaureInterruptions(void);

//==========================================================================//

void PressionTouche(short);

//==========================================================================//

void DrawSPECIAL_String(short, short, const char *, void *, void *, short);
void DrawSPECIAL_Number(short, short, unsigned long, void *, void *, short);

//==========================================================================//

void SauveImg(unsigned char *, void *, void *);
void RestaureImg(unsigned char *, void *, void *);
void GrayClrPix(short, short, void *, void *);
void GraySetPix(short, short, void *, void *);
void DessineLignes(void *, void *, short, short, short, short, short);
void DessineCerclePlein(void *, void *, short, short, short, short);

//==========================================================================//

void DecaleListeAnims(ANIM *, short, short);
void InitAnims(void);
void AfficheAnims(void);
void AfficheAnimsSpeciales(void);
void AfficheProjectiles(void);
void AfficheBonus(void);

//==========================================================================//

void Attend(short);
void TransitionBas(void);
void TransitionHaut(void);
void EnterEsc(void);
void AfficheAbort(short *);
void AfficheMsg(const char *);
void AfficheVaisseau(short, short);
void InitFond(void);
void DeplaceFond(void);
void AfficheMur(void);
void DeplaceBords(void);
void CopieBordsToScreen(void);
static inline void AfficheTitre(void);
static inline void AfficheLCD(void *);
void CopieEcranScore(void *, void *, void *, void *);
void AfficheScore(void);
void AfficheGameOver(void);
void GestionPause(void);
void EffaceTousEcrans(void);
void AfficheFondFelicitations(void);
void AfficheFelicitations(void);
void AffecteBonus(void);
void GenereBonus(void);
void AjusteContrasteHaut(void);
void AjusteContrasteBas(void);

//==========================================================================//

void InitMenu(void);
void CopieMenuFond(void);
void AfficheMenu(void);
void DessineCadreMenu(void);
void MenuOptions(void);
void MenuHiscores(void);
void MenuAbout(void);

//==========================================================================//

void InitBombes(short, short);
short CollisionVaisseauBonus(short, short);
unsigned short CollisionVaisseauBords(short, short);
short CollisionVaisseauAnims(short, short);
short CollisionVaisseauAnimsSpeciales(short, short);
short CollisionVaisseauProjectiles(short, short);
short CollisionVaisseau(short, short);
short CollisionBombesAnims(short, short);
short CollisionBombesOeil(short, short);
short CollisionBombesBords(short, short);
short CollisionBombesMur(short, short);
short CollisionBombesTrompe(short, short);
void InitListes(void);
void DecaleListeBombesEtProj(short *, short, short);
void AfficheBombes(void);

//==========================================================================//

static inline void OuvreFichierSauvegarde(void);
static inline void FermeFichierSauvegarde(void);
void HiScore(void);

//==========================================================================//

#endif